;****************************************************************
;****************************************************************
;****************************************************************
;***                                                          ***
;***                                                          ***
;***  File :    BrCnfg.asm                                    ***
;***  Version : 9.0                                           ***
;***  Revised : 31484                                       ***
;***                                                          ***
;***  Copyright (c) 1984 by Convergent Technologies Inc.      ***
;***                                                          ***
;***  INSTRUCTIONS FOR CONFIGURING THE BASIC COMPILER RUNTIME ***
;***                                                          ***
;***                                                          ***
;***   1.0  fnLim is declared in the CONST segment.  Use this ***
;***        variable to configure the default value for the   ***
;***        number of files that a BASIC program can open     ***
;***        concurrently.  The default is a maximum of 6      ***
;***        files open concurrently.                          ***
;***                                                          ***
;***                                                          ***
;***   2.0  sSamBuffer is declared in the CONST segment.  Use ***
;***        this variable to configure the buffer size for    ***
;***        sequential access (SAM) files.  The default       ***
;***        buffer size is 1024 bytes.                        ***
;***                                                          ***
;***                                                          ***
;***   3.0  cpWorkingSet is declared in the CONST segment.    ***
;***        Use this variable to configure the size in        ***
;***        in paragraphs of the overlay zone for swapping    ***
;***        programs.  A paragraph is 16 bytes.  The          ***
;***        default is an overlay zone of at least 1024       ***
;***        paragraphs (16K bytes).                           ***
;***                                                          ***
;***   4.0  cpFileSpace is declared in the CONST segment.     ***
;***        Use this variable to configure the size in        ***
;***        paragraphs of the memory area from which          ***
;***        file buffers are allocated.  A paragraph is       ***
;***        16 bytes.  The default is file space of 800       ***
;***        paragraphs (12800 bytes).                         ***
;***                                                          ***
;***                                                          ***
;***   5.0  cpStringSpace is declared in the CONST segment.   ***
;***        Use this variable to configure the size in        ***
;***        paragraphs of the memory area from which strings  ***
;***        are allocated.  A paragraph is 16 bytes.  The     ***
;***        default is string space of 512 paragraphs (8K     ***
;***        bytes).                                           ***
;***                                                          ***
;***                                                          ***
;***   6.0  cpFreeMemory is declared in the CONST segment.    ***
;***        Use this variable to configure the amount in      ***
;***        paragrphs of short lived memory which is left     ***
;***        unallocated.  A paragraphs is 16 bytes.  The      ***
;***        default is no short lived memory left unallocated.***
;***                                                          ***
;***   7.0  fClearExecScreen is declared in the CONST         ***
;***        segment.  If this flag is true, the Exec screen   ***
;***        is cleared before the BASIC program begins        ***
;***        executing.  If false, the screen is left          ***
;***        unchanged.  The default is true.                  ***
;***                                                          ***
;***                                                          ***
;****************************************************************
;****************************************************************


DGROUP  GROUP   DATA,CONST

DATA   SEGMENT PUBLIC 'DATA'
DATA   ENDS

CONST   SEGMENT PUBLIC 'CONST'

;************************************************
; fnLim = maximum number of open files
; 1.0  TO CHANGE THE MAXIMUM NUMBER OF OPEN FILES
;      CHANGE THE 6 TO THE NUMBER DESIRED.
fnLim		EQU	6
;************************************************


; fnMax = fnLim + 1
PUBLIC fnMax
fnMax		DW	fnLim+1


;************************************************
; 2.0  TO CHANGE THE SIZE OF SAM FILE BUFFERS    
;      CHANGE THE 1024 TO THE NUMBER DESIRED.
PUBLIC sSamBuffer
sSamBuffer	DW	1024
;************************************************


;************************************************
; 3.0  TO CHANGE THE SIZE OF THE OVERLAY ZONE    
;      CHANGE THE 1024 TO THE NUMBER DESIRED.
PUBLIC cpWorkingSet
cpWorkingSet	DW	1024
;************************************************


;************************************************
; 4.0  TO CHANGE THE AMOUNT OF FILE SPACE      
;      CHANGE THE 800 TO THE NUMBER DESIRED.
PUBLIC cpFileSpace
cpFileSpace	DW	800
;************************************************


;************************************************
; 5.0  TO CHANGE THE AMOUNT OF STRING SPACE    
;      CHANGE THE 512 TO THE NUMBER DESIRED.
PUBLIC cpStringSpace
cpStringSpace	DW	512
;************************************************


;************************************************
; 6.0  TO CHANGE THE AMOUNT OF FREE MEMORY       
;      CHANGE THE 0 TO THE NUMBER DESIRED.
PUBLIC cpFreeMemory
cpFreeMemory	DW	0
;************************************************

true equ 0ffh
false equ 0

;************************************************
; 7.0  TO CHANGE FClearExecScreen TO FALSE,        
;      CHANGE true TO false.
PUBLIC fClearExecScreen
fClearExecScreen	DB	true
;************************************************


CONST   ENDS


END
default value for the   ***
;***        number of files that a BASIC program can open     ***
;***        concurrently.  The default is a maximum of 6      ***
;***        files open concurrently.                          ***
;***                                                          ***
;***                                                          ***
;***   2.0  sSamBuffer is declared in the CONST segment.  Use ***
;***        this variable to configure the buffer size for    ***
;***        sequen