; AdminSystem>Install.jcl
; Install the Admin System Utilities subpackage

; Except for yesno strings, these two messages are the only nationalizable
; strings in this file.
ErrorMsg     = 'Cannot access message file'
FirstDisk    = 'System Utilities Diskette 3 of 4 (B25STP3)'

FromFloppy   = 0
FromServer   = 2
SysVolume    = '[Sys]'
BangSys      = '[Sys]'
SysCmds      = '[Sys]<sys>sys.cmds'
FloppySpec   = ConcatStrings(DeviceFrom, '<zAdmin>')
BinSpec      = ConcatStrings(DeviceFrom, '<Sys>')
ToSpec       = ConcatStrings(VolumeTo,   DirectoryTo)
FromSpec     = ConcatStrings(FloppySpec, '*')
NoSpec       = ConcatStrings(DeviceFrom, '<zNo>*')

ToSpec12.3.X = ConcatStrings(ToSpec, 'pre12.3.100>')

If InstallType = FromFloppy
    NextFloppy(FirstDisk)
    EndIf

InitErc = InitMsgFile(MsgFile)
If InitErc > 0
    DisplayLine(ErrorMsg)
    Cancel
    Endif

If Public
    Command Merge Command Files   ,
              CmdFileFrom         ,
              CmdFileTo           ,
              Yes                 ,
              VolumeTo

    Command Merge Command Files   ,
              CmdFileFrom         ,
              SysCmds             ,
              Yes                 ,
              BangSys
Else
    Command Merge Command Files   ,
              CmdFileFrom         ,
              CmdFileTo           ,
              Yes                 ,
              SysVolume
EndIf

Command LCopy                    ,
          'UserFileTemplate.sys' ,
          ToSpec                 ,
          ToSpec12.3.X           ,
                                 ,
          No                     ,
          No                     ,
          Yes

If InstallType = FromServer
    Command LCopy                                      ,
                                                       ,
              @[Scr]<$>InstallOverwriteOkFrom.fls      ,
              @[Scr]<$>InstallOverwriteOkTo.fls        ,
                                                       ,
              Yes                                      ,
              No                                       ,
              No
    Command LCopy                                      ,
                                                       ,
              @[Scr]<$>InstallOverwriteNoFrom.fls      ,
              @[Scr]<$>InstallOverwriteNoTo.fls        ,
                                                       ,
              No                                       ,
              No                                       ,
              No
    GoTo EndIt
    Endif

Command Decompress Files           ,
          FromSpec                 ,
                                   ,
          ToSpec                   ,
          Yes                      ,
          No                       

Command Decompress Files           ,
          NoSpec                   ,
                                   ,
          ToSpec                   ,
          No                       ,
          No

RestartLabel

Msg = GetMsg(1)
$NextFloppy(Msg)

Command Decompress Files           ,
          FromSpec                 ,
                                   ,
          ToSpec                   ,
          Yes                      ,
          No                       

RestartLabel

pkg = GetMsg(3)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(4)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(5)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(6)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(7)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(8)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(9)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(10)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(11)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(1)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(12)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(14)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

pkg = GetMsg(13)
If substring(pkg,pkgs) <> 65535
    Msg = GetMsg(14)
    NextFloppy(Msg)
    GoTo EndIt
    EndIf

EndIt:

End
