;******************************* MODULE HEADER *******************************;
;*                                                                           *;
;* FILE: Mediator.asm                                                        *;
;*                                                                           *;
;* MACHINE: NGenSGen   LANGUAGE: ASSEMBLER  OS: CTOS                        *;
;*                                                                           *;
;* DESCRIPTION:                                                              *;
;*                                                                           *;
;* Stack swapper for calling medium model object module routines from        *;
;* large model programs.  This swapping is required when linking medium      *;
;* model object modules from Unisys libraries into mediated DLLs.            *;
;*                                                                           *;
;* To add a mediated call, create a Mediate macro entry.  The two parameters *;
;* are the name of the routine written in nonlarge model and the number of  *;
;* bytes in the parameter list.                                              *;
;*                                                                           *;
;* For example:  To mediate calls to CloseByteStream, the macro would look   *;
;* like the following line without the leading and trailing semicolon        *;
;* asterisk, which denotes comment.                                         *;
;*                                                                           *;
;*   Mediate(ProcedureName,N)                                                *;
;* where                                                                     *;
;* N is the total number of bytes in the parameter list for the procedure.   *;
;* Parameters that are described as a byte should be counted as two(2) bytes *;
;* becuase parameters are always pushed onto the stack with wordallignment. *;
;* N should never be an odd value.                                           *;
;*                                                                           *;
;* TITLE:  CTOS SYSTEM SOFTWARE                                              *;
;*                                                                           *;
;*            PROPRIETARY PROGRAM MATERIAL                                   *;
;*                                                                           *;
;* THIS MATERIAL IS PROPRIETARY TO UNISYS CORPORATION AND IS NOT TO BE       *;
;* REPRODUCED, USED OR DISCLOSED EXCEPT IN ACCORDANCE WITH PROGRAM LICENSE   *;
;* OR UPON WRITTEN AUTHORIZATION OF THE PATENT DIVISION OF UNISYS            *;
;* CORPORATION, DETROIT, MICHIGAN 48232, USA.                                *;
;*                                                                           *;
;* COPYRIGHT (C) 1980, 1993 CONVERGENT INCORPORATED. ALL RIGHTS RESERVED     *;
;* COPYRIGHT (C) 1980, 1993 UNISYS CORPORATION. ALL RIGHTS RESERVED          *;
;* ************************************************************************* *;
;*                                                                           *;
;* UNISYS BELIEVES THAT THE SOFTWARE FURNISHED HEREWITH IS ACCURATE AND      *;
;* RELIABLE, AND MUCH CARE HAS BEEN TAKEN IN ITS PREPARATION.  HOWEVER,      *;
;* NO RESPONSIBILITY, FINANCIAL OR OTHERWISE, CAN BE ACCEPTED FOR ANY        *;
;* CONSEQUENCES ARISING OUT OF THE USE OF THIS MATERIAL, INCLUDING LOSS OF   *;
;* PROFIT, INDIRECT, SPECIAL, OR CONSEQUENTIAL DAMAGES, THERE ARE NO         *;
;* WARRANTIES WHICH EXTEND BEYOND THE PROGRAM SPECIFICATION.                 *;
;*                                                                           *;
;* THE CUSTOMER SHOULD EXERCISE CARE TO ASSURE THAT USE OF THE SOFTWARE      *;
;* WILL BE IN FULL COMPLIANCE WITH LAWS, RULES AND REGULATIONS OF THE        *;
;* JURISDICTIONS WITH RESPECT TO WHICH IT IS USED.                           *;
;*                                                                           *;
;*                                                                           *;
;*************************** END OF MODULE HEADER ****************************;

$INCLUDE(:f1:Mediator.mdf)

; Add mediated calls here
Mediate(CloseByteStream,4)

END
tP6PGPFtP6PGPFtP6PGPFueP6GFt8P6XPGPF@uP6PGPF t> P6P PGPFtP6PGPFuP6PGPFt@nP6P