SaveVidLevel = VideoLevel
EchoOff

; vServerOs>Install.jcl
; Install the VirtualMode Server Operating System subpackage

; Public installation is allowed for two reasons:
;    Headless servers (ala BULL)
;    Creation of a new server from an existing one.
; vSrvr.img is copied to [Sys]<Sys> and maybe [Sys]<Sys>SysImage.sys.

; Except for yesno strings  'First disk message' the following is the only 
; nationalizable string in this file.
ErrorMsg     = 'Cannot access vServerOs>InstallMsg.bin'

FromCD       = 5
FromFloppy   = 0
FromServer   = 2
FloppyType   = 0
Floppy5Qtr   = 1
Floppy3Half  = 4
NotFound     = 65535
TotalNoise   = 0
ClearScreen  = 'PF'

If InstallType = FromFloppy
   FloppyType   = DeviceType(DeviceFrom)
EndIf

; The following message is nationalizable
If FloppyType = Floppy5Qtr
   FirstDisk    = 'Virtual Mode OS Diskette 3 of 6 (B25V1036)'
Else
   If FloppyType = Floppy3Half
      FirstDisk   = 'Virtual Mode OS Diskette 2 of 3 (B25V1023)'
   EndIf
EndIf

If InstallType = FromFloppy
   NextFloppy(FirstDisk)
EndIf

ServerSpec   = ConcatStrings(DeviceFrom, DirectoryTo)
FloppySpec   = ConcatStrings(DeviceFrom, '<CTOS>')
ToSpec       = ConcatStrings(VolumeTo, DirectoryTo)
PrivateOsTo  = ConcatStrings(ToSpec, 'SysImage.sys')
EtcFromSpec  = ConcatStrings(DeviceFrom, '<OsInstall>')
OsName       = 'vSrvr.img'

ZippedOsSpec = ConcatStrings(FloppySpec, 'vSrvrimg.run')
ZipFromDir   = '\'<131gen>*\''
TempStringA  = ConcatStrings(DirectoryTo, '*\'')
UnZipToDir   = ConcatStrings('\'', TempStringA)
UnZippedOs   = ConcatStrings(ToSpec, 'vSrvr.img')

ConfigFile   = 'Config.sys'
NlsKbdFile   = 'NlsKbd.sys'
OtherFiles   = ConcatStrings(EtcFromSpec, 'SrvrCopy.fls')

OsFrom       = ConcatStrings(FloppySpec, OsName)

If Public
   OsTo = ConcatStrings(ToSpec, OsName)
Else
   OsTo = PrivateOsTo
EndIf

InitErc = InitMsgFile(MsgFile)
If InitErc <> 0
   DisplayLine(ErrorMsg)
   Cancel
EndIf

If InstallType = FromServer
   Display(ClearScreen)
   Msg = GetMsg(4)
   DisplayLine(Msg)
   Msg = GetMsg(5)
   DisplayLine(Msg)
   Msg = GetMsg(6)
   Confirmed = UserSelectYesNo(Msg, 'Yes')
   If Not Confirmed
      GoTo ChkPkgs
   EndIf
EndIf

Display(ClearScreen)

If Public
   Display(ClearScreen)
   Msg = GetMsg(7)
   OverwriteSys = UserSelectYesNo(Msg, 'Yes')
EndIf

If InstallType = FromServer
   OsFromServer = ConcatStrings(ServerSpec, OsName)
   DisplayLine
   If SaveVidLevel = TotalNoise
      EchoSome
   EndIf
   Command LCopy                                      ,
                                                      ,
             @[Scr]<$>InstallOverwriteOkFrom.fls      ,
             @[Scr]<$>InstallOverwriteOkTo.fls        ,
                                                      ,
             Yes                                      ,
             No                                       ,
             No                                       ,
             Yes
   DisplayLine
   Command LCopy           ,
                           ,
              OsFromServer ,
              PrivateOsTo  ,
                           ,
              Yes          ,
              No           ,
              No           ,
              Yes
   DisplayLine
   Command LCopy         ,
              ConfigFile ,
              ServerSpec ,
              ToSpec     ,
                         ,
              No         ,
              No         ,
              No         ,
              Yes
   If SaveVidLevel = TotalNoise
      EchoOff
   EndIf
   Msg = GetMsg(10)
   ConfigSpec = ConcatStrings(ToSpec, Msg)
   DisplayLine
   If SaveVidLevel = TotalNoise
      EchoSome
   EndIf
   Command LCopy         ,
              ConfigFile ,
              ServerSpec ,
              ConfigSpec ,
                         ,
              Yes        ,
              No         ,
              No         ,
              Yes
   If SaveVidLevel = TotalNoise
      EchoOff
   EndIf
   FileName = ConcatStrings(ToSpec, NlsKbdFile)
   Ver = FileVersion(FileName)
   If Ver <> '0'
      Msg = GetMsg(9)
      SaveSpec = ConcatStrings(ToSpec, Msg)
      FileName = ConcatStrings(SaveSpec, NlsKbdFile)
      Ver = FileVersion(FileName)
      If Ver = '0'
         DisplayLine
         If SaveVidLevel = TotalNoise
            EchoSome
         EndIf
         Command LCopy         ,
                    NlsKbdFile ,
                    ToSpec     ,
                    SaveSpec   ,
                               ,
                    No         ,
                    No         ,
                    No         ,
                    Yes
         If SaveVidLevel = TotalNoise
            EchoOff
         EndIf
         DisplayLine
         Msg = ConcatStrings(ToSpec, NlsKbdFile)
         Display(Msg)
         Msg = GetMsg(8)
         Display(Msg)
         Display(ToSpec)
         Msg = GetMsg(9)
         Display(Msg)
         DisplayLine(NlsKbdFile)
      EndIf
   EndIf
   DisplayLine
   If SaveVidLevel = TotalNoise
      EchoSome
   EndIf
   Command LCopy         ,
              NlsKbdFile ,
              ServerSpec ,
              ToSpec     ,
                         ,
              Yes        ,
              No         ,
              No         ,
              Yes
   If SaveVidLevel = TotalNoise
      EchoOff
   EndIf
   GoTo ChkPkgs
EndIf

; ********  INSTALL FROM FLOPPY....******************

If InstallType = FromFloppy

  If FloppyType = Floppy3Half

    If SaveVidLevel = TotalNoise
        EchoSome
    EndIf
    DisplayLine
    Command LCopy      ,
           ConfigFile  ,
           EtcFromSpec ,
           ToSpec      ,
                       ,
           No          ,
           No          ,
           No          ,
           Yes

    If SaveVidLevel = TotalNoise
        EchoOff
    EndIf
    Msg = GetMsg(10)
    ConfigSpec = ConcatStrings(ToSpec, Msg)
    DisplayLine

    If SaveVidLevel = TotalNoise
        EchoSome
    EndIf
    Command LCopy      ,
           ConfigFile  ,
           EtcFromSpec ,
           ConfigSpec  ,
                       ,
           Yes         ,
           No          ,
           No          ,
           Yes
    If SaveVidLevel = TotalNoise
        EchoOff
    EndIf

    FileName = ConcatStrings(ToSpec, NlsKbdFile)
    Ver = FileVersion(FileName)
    If Ver <> '0'
       Msg = GetMsg(9)
       SaveSpec = ConcatStrings(ToSpec, Msg)
       FileName = ConcatStrings(SaveSpec, NlsKbdFile)
       Ver = FileVersion(FileName)
       If Ver = '0'
          DisplayLine
          If SaveVidLevel = TotalNoise
              EchoSome
          EndIf
          Command LCopy         ,
                     NlsKbdFile ,
                     ToSpec     ,
                     SaveSpec   ,
                                ,
                     No         ,
                     No         ,
                     No         ,
                     Yes
          If SaveVidLevel = TotalNoise
              EchoOff
          EndIf
          DisplayLine
          Msg = ConcatStrings(ToSpec, NlsKbdFile)
          Display(Msg)
          Msg = GetMsg(8)
          Display(Msg)
          Display(ToSpec)
          Msg = GetMsg(9)
          Display(Msg)
          DisplayLine(NlsKbdFile)
       EndIf
    EndIf

    If SaveVidLevel = TotalNoise
         EchoSome
    EndIf
    Command LCopy          ,
               NlsKbdFile  ,
               EtcFromSpec ,
               ToSpec      ,
                           ,
               Yes         ,
               No          ,
               No          ,
               Yes
    DisplayLine
    Command LCopy          ,
              @OtherFiles  ,
              EtcFromSpec  ,
              ToSpec       ,
                           ,
              Yes          ,
              No           ,
              No           ,
              Yes

    DisplayLine

    Command LCopy     ,
                      ,
               OsFrom ,
               OsTo   ,
                      ,
               Yes    ,
               No     ,
               No     ,
               Yes

    DisplayLine
    If Public
       If OverwriteSys
          DisplayLine
          Command LCopy          ,
                                 ,
                     OsFrom      ,
                     PrivateOsTo ,
                                 ,
                     Yes         ,
                     No          ,
                     No          ,
                     Yes
       EndIf
    EndIf
    If SaveVidLevel = TotalNoise
         EchoOff
    EndIf

  EndIf
;       ****** End install from 3, start 5 *******

  If FloppyType = Floppy5Qtr
    DisplayLine
    If SaveVidLevel = TotalNoise
        EchoSome
    EndIf

    Command Run       			,
               ZippedOsSpec 	,
                            	,
                            	,
               ZipFromDir	 	,
               UnZipToDir   	,
               Yes          	,
               No             	,
                            	,
                            	,
               VolumeTo

    If SaveVidLevel = TotalNoise
        EchoOff
    EndIf

    DisplayLine
    If Public
       If OverwriteSys
          DisplayLine
          If SaveVidLevel = TotalNoise
              EchoSome
          EndIf
          Command LCopy            ,
                                   ,
                     UnZippedOs    ,
                     PrivateOsTo   ,
                                   ,
                     Yes           ,
                     No            ,
                     No            ,
                     Yes
          If SaveVidLevel = TotalNoise
              EchoOff
          EndIf
       EndIf
    EndIf

    Diskette = GetMsg(2)
    NextFloppy(Diskette)

    DisplayLine

    If SaveVidLevel = TotalNoise
        EchoSome
    EndIf
    Command LCopy      ,
           ConfigFile  ,
           EtcFromSpec ,
           ToSpec      ,
                       ,
           No          ,
           No          ,
           No          ,
           Yes
    If SaveVidLevel = TotalNoise
        EchoOff
    EndIf

    Msg = GetMsg(10)
    ConfigSpec = ConcatStrings(ToSpec, Msg)
    DisplayLine

    If SaveVidLevel = TotalNoise
        EchoSome
    EndIf
    Command LCopy      ,
           ConfigFile  ,
           EtcFromSpec ,
           ConfigSpec  ,
                       ,
           Yes         ,
           No          ,
           No          ,
           Yes
    If SaveVidLevel = TotalNoise
        EchoOff
    EndIf

    FileName = ConcatStrings(ToSpec, NlsKbdFile)
    Ver = FileVersion(FileName)
    If Ver <> '0'
       Msg = GetMsg(9)
       SaveSpec = ConcatStrings(ToSpec, Msg)
       FileName = ConcatStrings(SaveSpec, NlsKbdFile)
       Ver = FileVersion(FileName)
       If Ver = '0'
          DisplayLine
          If SaveVidLevel = TotalNoise
              EchoSome
          EndIf
          Command LCopy         ,
                     NlsKbdFile ,
                     ToSpec     ,
                     SaveSpec   ,
                                ,
                     No         ,
                     No         ,
                     No         ,
                     Yes
          If SaveVidLevel = TotalNoise
              EchoOff
          EndIf
          DisplayLine
          Msg = ConcatStrings(ToSpec, NlsKbdFile)
          Display(Msg)
          Msg = GetMsg(8)
          Display(Msg)
          Display(ToSpec)
          Msg = GetMsg(9)
          Display(Msg)
          DisplayLine(NlsKbdFile)
       EndIf
    EndIf

    If SaveVidLevel = TotalNoise
        EchoSome
    EndIf
    Command LCopy          ,
               NlsKbdFile  ,
               EtcFromSpec ,
               ToSpec      ,
                           ,
               Yes         ,
               No          ,
               No          ,
               Yes
    DisplayLine
    Command LCopy          ,
              @OtherFiles  ,
              EtcFromSpec  ,
              ToSpec       ,
                           ,
              Yes          ,
              No           ,
              No           ,
              Yes

    DisplayLine

    If SaveVidLevel = TotalNoise
        EchoOff
    EndIf

  EndIf ;   ****** End  5 *******

EndIf; *** End FromFloppy ***

ChkPkgs:
DisplayLine

;Next SubPackage:    vStnd OS 
Pkg = GetMsg(1)
If SubString(Pkg, Pkgs) <> NotFound
   GoTo EndIt
EndIf

;Next SubPackage:    vDebugger 
Pkg = GetMsg(3)
If SubString(Pkg, Pkgs) <> NotFound
   If FloppyType = Floppy5Qtr
      Diskette = GetMsg(13)
      NextFloppy(Diskette)
   Else
      If FloppyType = Floppy3Half
         Diskette = GetMsg(12)
         NextFloppy(Diskette)
      EndIf
   EndIf
   GoTo EndIt
EndIf

EndIt:
End
